--- a/net/minecraft/server/EntitySmallFireball.java
+++ b/net/minecraft/server/EntitySmallFireball.java
@@ -1,5 +1,7 @@
 package net.minecraft.server;
 
+import org.bukkit.event.entity.EntityCombustByEntityEvent; // CraftBukkit
+
 public class EntitySmallFireball extends EntityFireballFireball {
 
     public EntitySmallFireball(EntityTypes<? extends EntitySmallFireball> entitytypes, World world) {
@@ -8,6 +10,11 @@
 
     public EntitySmallFireball(World world, EntityLiving entityliving, double d0, double d1, double d2) {
         super(EntityTypes.SMALL_FIREBALL, entityliving, d0, d1, d2, world);
+        // CraftBukkit start
+        if (this.getShooter() != null && this.getShooter() instanceof EntityInsentient) {
+            isIncendiary = this.world.getGameRules().getBoolean(GameRules.MOB_GRIEFING);
+        }
+        // CraftBukkit end
     }
 
     public EntitySmallFireball(World world, double d0, double d1, double d2, double d3, double d4, double d5) {
@@ -24,7 +31,16 @@
                 Entity entity1 = this.getShooter();
                 int i = entity.getFireTicks();
 
-                entity.setOnFire(5);
+                // CraftBukkit start - Entity damage by entity event + combust event
+                if (isIncendiary) {
+                    EntityCombustByEntityEvent event = new EntityCombustByEntityEvent((org.bukkit.entity.Projectile) this.getBukkitEntity(), entity.getBukkitEntity(), 5);
+                    entity.world.getServer().getPluginManager().callEvent(event);
+
+                    if (!event.isCancelled()) {
+                        entity.setOnFire(event.getDuration(), false);
+                    }
+                }
+                // CraftBukkit end
                 boolean flag = entity.damageEntity(DamageSource.fireball(this, entity1), 5.0F);
 
                 if (!flag) {
@@ -43,10 +59,10 @@
         if (!this.world.isClientSide) {
             Entity entity = this.getShooter();
 
-            if (entity == null || !(entity instanceof EntityInsentient) || this.world.getGameRules().getBoolean(GameRules.MOB_GRIEFING)) {
+            if (isIncendiary) { // CraftBukkit
                 BlockPosition blockposition = movingobjectpositionblock.getBlockPosition().shift(movingobjectpositionblock.getDirection());
 
-                if (this.world.isEmpty(blockposition)) {
+                if (this.world.isEmpty(blockposition) && !org.bukkit.craftbukkit.event.CraftEventFactory.callBlockIgniteEvent(world, blockposition, this).isCancelled()) { // CraftBukkit
                     this.world.setTypeUpdate(blockposition, BlockFireAbstract.a((IBlockAccess) this.world, blockposition));
                 }
             }
